
CoCoALib - Feature #1482

Extended rationals: PlusInfinity and MinusInfinity

31 Aug 2020 13:56 - John Abbott

Status: In Progress Start date: 31 Aug 2020

Priority: Normal Due date:  

Assignee:  % Done: 10%

Category: New Function Estimated time: 0.00 hour

Target version: CoCoALib-0.99900 Spent time: 1.30 hour

Description

Might we be interested in having representations of PlusInfinity and MinusInfinty?

This could be useful for non-finite intervals.  A possible represemtation could be as the "malformed" rationals 1/0 and -1/0.

Related issues:

Related to CoCoALib - Feature #1176: interval arithmetic In Progress 05 Apr 2018

History

#1 - 31 Aug 2020 13:56 - John Abbott

- Related to Feature #1176: interval arithmetic added

#2 - 31 Aug 2020 14:02 - John Abbott

Some notes:

what type should these values have?  BigRat?  Or Maybe ExtendedBigRat?

We'd probably need functions such as IsInfinite

Which operations should work on infinite values?  Sign?  Comparisons?

Is PlusInfinity == PlusInfinity?

What about arithmetic?  Some operations coul reasonably be defined: e.g. finite + PlusInfinity should give PlusInfinity, etc.

It may not be worth it.  It could be tricky/tedious putting in all the checks to handle infinities in comparisons, and arithmetic operations...

#3 - 31 Aug 2020 14:48 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

The doc for GMP states fairly clearly that the rationals 1/0 and -1/0 can be created, but that they may not be passed to arithmetic functions.

It is not clear whether they may be used safely in comparison functions; probably we should assume that it is not safe.

#4 - 31 Aug 2020 14:56 - John Abbott

Maybe the simple approach is to create two new types: PlusInfinityType and MinusInfinityType.  Then it should be easy to write the special casee

functions: e.g. PlusInfinityType operator+(const BigRat&, PlusInfinityType)

Uniform handling inside the interval code might be rather tedious... :-(

#5 - 16 Feb 2024 18:02 - John Abbott

28 Apr 2024 1/2



- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99900
